/*
 * Asynchronous Message Passing Channel
 * 
 */

public class AsyncChannel extends Object {

  private Object[] buffer;
  private int size;

  private int front;
  private int rear;

  private sema empty;
  private sema full;

  private Object snd;
  private Object rcv;

  /**
   * Constructs a AsyncChannel
   * @param init
   */
  public AsyncChannel(int init) {
    buffer = new Object[init];
    size = init;
    for (int i=0; i<size; i++) { buffer[i] = null; }
    front = 0;
    rear = 0;
    empty = new sema(init);
    full = new sema(0);
    snd = new Object();
    rcv = new Object();
  }


  /**
   * test if AsyncChannel is empty
   */
  public boolean empty() {
     return ( (front == rear) ); // && ( buffer[front] != null ) );
  }


  /**
   * Send an object through AsyncChannel
   * @param v
   */
  public void send(Object v) {

    empty.P();
    synchronized (snd) {
//      System.out.print("+");
      buffer[ rear ] = v; 
      rear++; if (rear >= size) rear -= size;
    }
    full.V();

  }

  /**
   * Receive an object from a AsyncChannel
   */
  public Object receive() {
    Object v;

    full.P();
    synchronized (rcv) {
//      System.out.print("-");
      v = buffer[ front ]; 
      front++; if (front >= size) front -= size;
    }
    empty.V();

    return v;
  }

}
