/*
 * Synchronous Message Passing Channel
 * 
 */

public class SyncChannel extends Object {

  private Object buffer;
  private boolean data;

  private sema empty;
  private sema full;

  private Object snd;

  /**
   * Constructs a SyncChannel
   * @param init
   */
  public SyncChannel() {
    buffer = new Object();
    data = false;
    empty = new sema(0);
    full = new sema(0);
    snd = new Object();
  }


  /**
   * Test SyncChannel empty
   */
  public boolean empty() {
    return ! data;
  }

  /**
   * Send an object through SyncChannel
   * @param v
   */
  public void send(Object v) {
    synchronized (snd) {
      buffer = v; 
      data = true;
//      System.out.print("snd: " + Thread.currentThread().getName() + " ");
      full.V();
      empty.P();
    }
  }

  /**
   * Receive an object from a SyncChannel
   */
  public Object receive() {
    Object v;

    full.P();
    v = buffer; 
    data = false;
//    System.out.print("rcv: " + Thread.currentThread().getName() + " ");
    empty.V();

    return v;
  }

}
